// MQL4&5-code

template <typename T>
struct STRUCT_TYPE
{
  T Value;

  STRUCT_TYPE( void )
  {
  }

  STRUCT_TYPE( const T& tValue )
  {
    this.Value = tValue;
  }
};

template <typename T>
struct STRUCT_READ
{
  uchar Bytes[sizeof(T)];

  template <typename T1>
  const STRUCT_READ<T1> GetStruct( const T1 &Value ) const
  {
    const STRUCT_TYPE<T1> Res(Value);

    return((STRUCT_READ<T1>)Res);
  }

  STRUCT_READ<T> Init( const T &Value )
  {
    this = this.GetStruct(Value);

    return(this);
  }

  template <typename T1>
  bool operator ==( const T1 &Value ) const
  {
    return(::ArrayCompare(this.Bytes, this.GetStruct(Value).Bytes) == 0);
  }

  template <typename T1>
  bool operator !=( const T1 &Value ) const
  {
    return(!(this == Value));
  }

  //    
  template <typename T1>
  T1 operator []( const T1 Pos ) const
  {
    STRUCT_TYPE<T1> Res = {0};
    const int iPos = (int)Pos;

    if (iPos + sizeof(T1) <= ::ArraySize(this.Bytes))
    {
      STRUCT_READ<T1> Tmp = {0};

      ::ArrayCopy(Tmp.Bytes, this.Bytes, 0, iPos, sizeof(T1));

      Res = (STRUCT_TYPE<T1>)Tmp;
    }

    return(Res.Value);
  }

#define WRITE_DEFINE(A, B)                                       \
  template <typename T1>                                         \
  bool Write##A( T &Target, const int Pos, const T1 B )          \
  {                                                              \
    const bool Res = (Pos + sizeof(Value) <= sizeof(Target));    \
                                                                 \
    if (Res)                                                     \
    {                                                            \
      ::ArrayCopy(this.Bytes, this.GetStruct(Value).Bytes, Pos); \
                                                                 \
      Target = ((STRUCT_TYPE<T>)this).Value;                     \
    }                                                            \
                                                                 \
    return(Res);                                                 \
  }

  WRITE_DEFINE(1, Value)
  WRITE_DEFINE(2, &Value)

#undef WRITE_DEFINE
};

//    -   operator=(T&)    return
template <typename T>
class CLASS_WRITE
{
private:
  static CLASS_WRITE<T> Object;

  T Data;
  int Pos;

public:
  static CLASS_WRITE<T>* Init( const T &Value )
  {
    (CLASS_WRITE<T>::Object).Data = Value;
    (CLASS_WRITE<T>::Object).Pos = 0;

    return(&CLASS_WRITE<T>::Object);
  }

  CLASS_WRITE<T>* operator []( const int iPos )
  {
    this.Pos = iPos;

    return(&this);
  }

#define OPERATOR_DEFINE(A, B)                                 \
  template <typename T1>                                      \
  const T operator =( const T1 B )                            \
  {                                                           \
    STRUCT_READ<T> Res;                                       \
                                                              \
    Res.Init(this.Data).Write##A(this.Data, this.Pos, Value); \
                                                              \
    return(this.Data);                                        \
  }

  OPERATOR_DEFINE(1, Value)
  OPERATOR_DEFINE(2, &Value)

#undef OPERATOR_DEFINE
};

template <typename T>
static CLASS_WRITE<T> CLASS_WRITE::Object();

class TYPETOBYTES
{
public:
  template <typename T>
  static STRUCT_READ<T> Read( const T &Value )
  {
    STRUCT_READ<T> Res;

    return(Res.Init(Value));
  }

  template <typename T>
  static CLASS_WRITE<T>* Write( const T &Value )
  {
    return(CLASS_WRITE<T>::Init(Value));
  }

  template <typename T1, typename T2>
  static int Offset( T1 &Struct, T2 &Field )
  {
    int Res = 0;

    STRUCT_READ<T1> NewStruct = {0};

    if (::ArrayInitialize(NewStruct.Bytes, CHAR_MAX) == sizeof(T1))
    {
      const T1 TmpStruct = Struct;

      Struct = (T1)NewStruct;
      Field = 0;

      NewStruct = (STRUCT_READ<T1>)Struct;

      while (Res < sizeof(T1))
      {
        if (NewStruct.Bytes[Res] == 0)
          break;

        Res++;
      }

      Struct = TmpStruct;
    }

    return(Res);
  }
};

#define _R(A) TYPETOBYTES::Read(A)
#define _W(A) A=TYPETOBYTES::Write(A)
#define _OFFSET(A,B) TYPETOBYTES::Offset(A, A.B)